;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : AT90S8535
;Clock frequency     : 4,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 128 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Automatic register allocation : On

	.DEVICE AT90S8535
	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU RAMPZ=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x40
	.EQU __sm_mask=0x30
	.EQU __sm_powerdown=0x20

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	RCALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	RCALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOV  R30,R0
	MOV  R31,R1
	.ENDM

	.MACRO __GETB2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOV  R26,R0
	MOV  R27,R1
	.ENDM

	.MACRO __GETBRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOV  R30,R28
	MOV  R31,R29
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOV  R26,R28
	MOV  R27,R29
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "MPP.vec"
	.INCLUDE "MPP.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x200)
	LDI  R25,HIGH(0x200)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM
	ADIW R30,1
	MOV  R22,R30
	MOV  R23,R31
	MOV  R31,R0
	MOV  R30,R1
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM
	ADIW R30,1
	MOV  R26,R0
	LPM
	ADIW R30,1
	MOV  R27,R0
	LPM
	ADIW R30,1
	MOV  R24,R0
	LPM
	ADIW R30,1
	MOV  R25,R0
__GLOBAL_INI_LOOP:
	LPM
	ADIW R30,1
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOV  R30,R22
	MOV  R31,R23
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x25F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x25F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0xE0)
	LDI  R29,HIGH(0xE0)

	RJMP _main

	.ESEG
	.ORG 0
	.DB  0 ; FIRST EEPROM LOCATION NOT USED, SEE ATMEL ERRATA SHEETS

	.DSEG
	.ORG 0xE0
;       1 /*********************************************
;       2 Project : PPE Dtection d'Obstacle (Commande d'un moteur pas  pas)
;       3 Version : 1
;       4 Date    : 02/2004
;       5 Author  : Jonet - Labonne               
;       6 Company : LYCEE Pierre Emile MARTIN       
;       7 Comments: Commande d'un moteur pas  pas aprs avoir rgl
;       8           le sens de dplacement(Horaire, Hanti horaire et
;       9           le nombre de pas ( 12 max)
;      10 Chip type           : AT90S8535
;      11 Clock frequency     : 4,000000 MHz
;      12 Memory model        : Small
;      13 Internal SRAM size  : 512
;      14 External SRAM size  : 0
;      15 Data Stack size     : 128
;      16 *********************************************/
;      17 
;      18 #include <90s8535.h>
;      19 
;      20 // Librairies non gnres par Wizard (rajoutes manuellement)      
;      21 #include <ssi.h>      // contient les fonctions Lire_BP,Affiche_LCD,Regdebit,Select_Seringue 
;      22 #include <delay.h>    // contient la fonction delay_ms
;      23 #include <stdio.h>    // contient la fonction sprintf
;      24 
;      25 // Etats du graphe des transitions "Menu"
;      26 #define Reglage	 	0
;      27 #define Marche	 	1
;      28 #define ReglagePas	2    
;      29 #define ChoixSens	3
;      30 
;      31 // Code des BPs de la carte AT90S8535 SSI
;      32 #define INC		0x1F
;      33 #define DEC		0x2F
;      34 #define OK		0x37
;      35 #define ECHAP		0x3B
;      36 #define SET		0x3D
;      37 #define ENTR		0x3E
;      38 
;      39 // Alphanumeric LCD Module functions
;      40 #asm
;      41    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      42 #endasm

;      43 #include <lcd.h>  
;      44 
;      45 // Prototypes des fonctions
;      46 unsigned char droite(void);  // rotation  droite
;      47 unsigned char gauche(void);  // rotation  gauche
;      48 
;      49 
;      50 //--------------------
;      51 // Programme principal
;      52 //--------------------
;      53 
;      54 void main(void)
;      55 {

	.CSEG
_main:
;      56 // Declare your local variables here
;      57 //----------------------------------
;      58 char display_buffer_ligne0[17]; // tampon ligne 0 de l'afficheur
;      59 char display_buffer_ligne1[17]; // tampon ligne 1 de l'afficheur
;      60 unsigned char etat = Reglage, etat_1 = Marche; // variables du graphe Menu
;      61 unsigned char BP; // BP = code ou tat de la touche slectionne			    
;      62 unsigned char Npas=0, Npas_1,sens=1; 
;      63 
;      64 // Input/Output Ports initialization
;      65 // Port A
;      66 PORTA=0x3F;
	SBIW R28,34
;	display_buffer_ligne0 -> Y+17
;	display_buffer_ligne1 -> Y+0
;	etat -> R16
;	etat_1 -> R17
;	BP -> R18
;	Npas -> R19
;	Npas_1 -> R20
;	sens -> R21
	LDI  R16,0
	LDI  R17,1
	LDI  R19,0
	LDI  R21,1
	LDI  R30,LOW(63)
	OUT  0x1B,R30
;      67 DDRA=0x00;
	CLR  R30
	OUT  0x1A,R30
;      68 
;      69 // Port B
;      70 PORTB=0x00;      		       			
	RCALL SUBOPT_0x0
;      71 DDRB=0x1f;
	LDI  R30,LOW(31)
	OUT  0x17,R30
;      72 
;      73 // LCD module initialization
;      74 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	RCALL _lcd_init
;      75 
;      76 while (1)
_0x25:
;      77   {
;      78       BP = Lire_BP();
	RCALL _Lire_BP
	MOV  R18,R30
;      79       
;      80       switch (etat)
	RCALL SUBOPT_0x1
;      81       {
;      82        case Reglage : if (etat_1 != etat)
	BRNE _0x2B
	CP   R16,R17
	BREQ _0x2C
;      83                        {
;      84                         PORTB = 0x00;  // dsactivation du moteur
	RCALL SUBOPT_0x0
;      85                         sprintf(display_buffer_ligne0,"OK>PAS ENTR>SENS");
	RCALL SUBOPT_0x2
	__POINTW1FN _36,0
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x3
;      86                     	sprintf(display_buffer_ligne1,"SET -> RUN");
	RCALL SUBOPT_0x4
	__POINTW1FN _36,17
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x3
;      87                     	Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x5
;      88                        }
;      89                        if (BP==OK) etat = ReglagePas;
_0x2C:
	CPI  R18,55
	BRNE _0x2D
	LDI  R16,LOW(2)
;      90                       		else if (BP==SET) etat = Marche;
	RJMP _0x2E
_0x2D:
	CPI  R18,61
	BRNE _0x2F
	LDI  R16,LOW(1)
;      91                       	       		else if (BP==ENTR) etat = ChoixSens;
	RJMP _0x30
_0x2F:
	CPI  R18,62
	BRNE _0x31
	LDI  R16,LOW(3)
;      92                       		               else etat = Reglage;
	RJMP _0x32
_0x31:
	LDI  R16,LOW(0)
_0x32:
_0x30:
_0x2E:
;      93        		       etat_1 = Reglage; 
	LDI  R17,LOW(0)
;      94        break;
	RJMP _0x2A
;      95        		   
;      96        case Marche :     if (sens==0) sprintf(display_buffer_ligne0,"Horaire");
_0x2B:
	CPI  R30,LOW(0x1)
	BRNE _0x33
	CPI  R21,0
	BRNE _0x34
	RCALL SUBOPT_0x2
	__POINTW1FN _36,28
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RJMP _0x115
;      97        				else sprintf(display_buffer_ligne0,"Anti horaire");
_0x34:
	RCALL SUBOPT_0x2
	__POINTW1FN _36,36
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
_0x115:
	RCALL _sprintf
	ADIW R28,4
;      98                     	 sprintf(display_buffer_ligne1,"PAS=%d",Npas);
	RCALL SUBOPT_0x4
	__POINTW1FN _36,49
	RCALL SUBOPT_0x6
	LDI  R24,4
	RCALL SUBOPT_0x7
;      99                     	 Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x5
;     100                          
;     101                          if (sens==1)
	CPI  R21,1
	BRNE _0x36
;     102                                 {
;     103        				  while (Npas!=0)
_0x37:
	CPI  R19,0
	BREQ _0x39
;     104 	    		              {
;     105 	    		                PORTB=droite();
	RCALL _droite
	OUT  0x18,R30
;     106 	     				Npas=Npas-1;
	SUBI R19,LOW(1)
;     107 	   			      } 
	RJMP _0x37
_0x39:
;     108 				}
;     109     			     else  
	RJMP _0x3A
_0x36:
;     110    				{ 
;     111    			         while (Npas!=0)
_0x3B:
	CPI  R19,0
	BREQ _0x3D
;     112 	   			      {
;     113 	    		                PORTB=gauche();
	RCALL _gauche
	OUT  0x18,R30
;     114 	    		                Npas=Npas-1;
	SUBI R19,LOW(1)
;     115 	   			      }
	RJMP _0x3B
_0x3D:
;     116 	   			 }                          
_0x3A:
;     117                        delay_ms(1500); 
	LDI  R30,LOW(1500)
	LDI  R31,HIGH(1500)
	RCALL SUBOPT_0x8
;     118        		       etat = Reglage;
	LDI  R16,LOW(0)
;     119                        etat_1 = Marche;
	LDI  R17,LOW(1)
;     120        break;
	RJMP _0x2A
;     121                       
;     122        case ReglagePas:  if (Npas==-1) Npas = 12;
_0x33:
	CPI  R30,LOW(0x2)
	BRNE _0x3E
	CPI  R19,255
	BRNE _0x3F
	LDI  R19,LOW(12)
;     123   				else if (Npas > 12) Npas = 0; 
	RJMP _0x40
_0x3F:
	LDI  R30,LOW(12)
	CP   R30,R19
	BRSH _0x41
	LDI  R19,LOW(0)
;     124   				
;     125    		         if ((Npas_1 != Npas) || (etat_1 != etat))
_0x41:
_0x40:
	CP   R19,R20
	BRNE _0x43
	CP   R16,R17
	BREQ _0x42
_0x43:
;     126      			  {
;     127       			   sprintf(display_buffer_ligne0,"INC/DEC -> +/-");
	RCALL SUBOPT_0x2
	__POINTW1FN _36,56
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x3
;     128       		           sprintf(display_buffer_ligne1,"%-u pas ECHP->FIN",Npas);
	RCALL SUBOPT_0x4
	__POINTW1FN _36,71
	RCALL SUBOPT_0x6
	LDI  R24,4
	RCALL SUBOPT_0x7
;     129       			   Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1);
	RCALL SUBOPT_0x5
;     130       			   Npas_1 = Npas;
	MOV  R20,R19
;     131      			  }
;     132      			 switch(BP)
_0x42:
	MOV  R30,R18
;     133      		          {
;     134       			    case INC   : Npas = Npas + 1; break;
	CPI  R30,LOW(0x1F)
	BRNE _0x48
	SUBI R19,-LOW(1)
	RJMP _0x47
;     135       			    case DEC   : Npas = Npas - 1; break;
_0x48:
	CPI  R30,LOW(0x2F)
	BRNE _0x49
	SUBI R19,LOW(1)
	RJMP _0x47
;     136       			    case ECHAP : etat = Reglage;
_0x49:
	CPI  R30,LOW(0x3B)
	BRNE _0x47
	LDI  R16,LOW(0)
;     137      		          }
_0x47:
;     138                         etat_1 = ReglagePas;
	LDI  R17,LOW(2)
;     139        break;
	RJMP _0x2A
;     140        
;     141        case ChoixSens: if (etat_1 != etat)
_0x3E:
	CPI  R30,LOW(0x3)
	BRNE _0x2A
	CP   R16,R17
	BREQ _0x4C
;     142                             {
;     143                             sprintf(display_buffer_ligne0,"DEC->AH, INC->H");
	RCALL SUBOPT_0x2
	__POINTW1FN _36,89
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x3
;     144                             sprintf(display_buffer_ligne1,"ECHAP -> FIN");
	RCALL SUBOPT_0x4
	__POINTW1FN _36,105
	ST   -Y,R31
	ST   -Y,R30
	LDI  R24,0
	RCALL SUBOPT_0x3
;     145                             Affiche_LCD(display_buffer_ligne0,display_buffer_ligne1); 	
	RCALL SUBOPT_0x2
	RCALL SUBOPT_0x5
;     146                             } 
;     147                             if (BP==ECHAP) etat = Reglage;
_0x4C:
	CPI  R18,59
	BRNE _0x4D
	LDI  R16,LOW(0)
;     148                                          else if (BP==DEC) {sens = 1; etat = Reglage;}
	RJMP _0x4E
_0x4D:
	CPI  R18,47
	BRNE _0x4F
	LDI  R21,LOW(1)
	LDI  R16,LOW(0)
;     149                                               else if (BP==INC) {sens = 0; etat = Reglage;}
	RJMP _0x50
_0x4F:
	CPI  R18,31
	BRNE _0x51
	LDI  R21,LOW(0)
	LDI  R16,LOW(0)
;     150                       		              		else etat = ChoixSens;
	RJMP _0x52
_0x51:
	LDI  R16,LOW(3)
_0x52:
_0x50:
_0x4E:
;     151                             etat_1 = ChoixSens;
	LDI  R17,LOW(3)
;     152        break;
;     153       } // fin du switch
_0x2A:
;     154    } // fin du while
	RJMP _0x25
;     155 } // fin du prog principal
	ADIW R28,34
_0x53:
	RJMP _0x53
;     156 
;     157 
;     158 //Sous programme sens(droite)
;     159 unsigned char droite(void)
;     160 {
_droite:
;     161 static unsigned char pas=1; 

	.DSEG

	.CSEG
;     162 unsigned char Moteur;
;     163  
;     164   switch (pas)
	ST   -Y,R16
;	Moteur -> R16
	MOV  R30,R4
;     165   {   
;     166        case 1 : Moteur=5 ; delay_ms(500) ;pas=2 ; break ;
	CPI  R30,LOW(0x1)
	BRNE _0x58
	LDI  R16,LOW(5)
	RCALL SUBOPT_0x9
	LDI  R30,LOW(2)
	MOV  R4,R30
	RJMP _0x57
;     167        case 2 : Moteur=6 ; delay_ms(500) ;pas=3 ; break ;
_0x58:
	CPI  R30,LOW(0x2)
	BRNE _0x59
	LDI  R16,LOW(6)
	RCALL SUBOPT_0x9
	LDI  R30,LOW(3)
	MOV  R4,R30
	RJMP _0x57
;     168        case 3 : Moteur=10 ; delay_ms(500);pas=4 ; break ;
_0x59:
	CPI  R30,LOW(0x3)
	BRNE _0x5A
	LDI  R16,LOW(10)
	RCALL SUBOPT_0x9
	LDI  R30,LOW(4)
	MOV  R4,R30
	RJMP _0x57
;     169        case 4 : Moteur=9 ; delay_ms(500) ;pas=1 ; break ;            
_0x5A:
	CPI  R30,LOW(0x4)
	BRNE _0x57
	LDI  R16,LOW(9)
	RCALL SUBOPT_0x9
	LDI  R30,LOW(1)
	MOV  R4,R30
;     170   }
_0x57:
;     171   return Moteur;
	MOV  R30,R16
	RJMP _0x114
;     172 } //fin Sous programme sens(droite)
;     173 
;     174 
;     175 //Sous programme sens(gauche)
;     176 unsigned char gauche(void)                        
;     177 {
_gauche:
;     178 static unsigned char pas=1;  

	.DSEG

	.CSEG
;     179 unsigned char Moteur;
;     180 
;     181   switch (pas)
	ST   -Y,R16
;	Moteur -> R16
	MOV  R30,R5
;     182   {     
;     183        case 1 : Moteur=9 ; delay_ms(500) ;pas=2 ; break ;
	CPI  R30,LOW(0x1)
	BRNE _0x60
	LDI  R16,LOW(9)
	RCALL SUBOPT_0x9
	LDI  R30,LOW(2)
	MOV  R5,R30
	RJMP _0x5F
;     184        case 2 : Moteur=10 ; delay_ms(500);pas=3 ; break ;
_0x60:
	CPI  R30,LOW(0x2)
	BRNE _0x61
	LDI  R16,LOW(10)
	RCALL SUBOPT_0x9
	LDI  R30,LOW(3)
	MOV  R5,R30
	RJMP _0x5F
;     185        case 3 : Moteur=6 ; delay_ms(500) ;pas=4 ; break ;
_0x61:
	CPI  R30,LOW(0x3)
	BRNE _0x62
	LDI  R16,LOW(6)
	RCALL SUBOPT_0x9
	LDI  R30,LOW(4)
	MOV  R5,R30
	RJMP _0x5F
;     186        case 4 : Moteur=5 ; delay_ms(500) ;pas=1 ; break ;
_0x62:
	CPI  R30,LOW(0x4)
	BRNE _0x5F
	LDI  R16,LOW(5)
	RCALL SUBOPT_0x9
	LDI  R30,LOW(1)
	MOV  R5,R30
;     187   }
_0x5F:
;     188   return Moteur;    
	MOV  R30,R16
_0x114:
	LD   R16,Y+
	RET
;     189 } //fin Sous programme sens(gauche)                   
;     190 
;     191 
_Lire_BP:

	.DSEG

	.CSEG
	RCALL __SAVELOCR2
	IN   R17,25
	ANDI R17,LOW(63)
	MOV  R30,R6
	CPI  R30,LOW(0x1)
	BRNE _0x68
	CPI  R17,63
	BRNE _0x69
	MOV  R16,R17
	RCALL SUBOPT_0xA
	IN   R17,25
	ANDI R17,LOW(63)
	CP   R17,R16
	BRNE _0x6A
	CLR  R6
	LDI  R30,LOW(255)
	RJMP _0x113
_0x6A:
	CLR  R30
	RJMP _0x113
	RJMP _0x6C
_0x69:
	CLR  R30
	RJMP _0x113
_0x6C:
	RJMP _0x67
_0x68:
	CPI  R30,0
	BRNE _0x67
	CPI  R17,63
	BREQ _0x6E
	MOV  R16,R17
	RCALL SUBOPT_0xA
	IN   R17,25
	ANDI R17,LOW(63)
	CP   R17,R16
	BRNE _0x6F
	LDI  R30,LOW(1)
	MOV  R6,R30
	MOV  R30,R17
	RJMP _0x113
_0x6F:
	LDI  R30,LOW(255)
	RJMP _0x113
	RJMP _0x71
_0x6E:
	LDI  R30,LOW(255)
_0x71:
_0x67:
_0x113:
	RCALL __LOADLOCR2P
	RET
_Affiche_LCD:
	RCALL _lcd_clear
	LDD  R30,Y+2
	LDD  R31,Y+2+1
	RCALL SUBOPT_0xB
	RCALL SUBOPT_0xC
	RCALL SUBOPT_0xD
	RCALL _lcd_gotoxy
	LD   R30,Y
	LDD  R31,Y+1
	RCALL SUBOPT_0xB
	ADIW R28,4
	RET
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G3:
	put:
	RCALL SUBOPT_0xE
	SBIW R30,0
	BREQ _0xA9
	RCALL SUBOPT_0xE
	ADIW R30,1
	RCALL __PUTWP1
	SBIW R30,1
	MOV  R26,R30
	MOV  R27,R31
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0xAA
_0xA9:
	LDD  R30,Y+2
	ST   -Y,R30
	RCALL _putchar
_0xAA:
	ADIW R28,3
	RET
__print_G3:
	SBIW R28,6
	RCALL __SAVELOCR6
	LDI  R16,0
_0xAC:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM
	MOV  R30,R0
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+2
	RJMP _0xAE
	RCALL SUBOPT_0x1
	BRNE _0xB2
	CPI  R19,37
	BRNE _0xB3
	LDI  R16,LOW(1)
	RJMP _0xB4
_0xB3:
	RCALL SUBOPT_0xF
_0xB4:
	RJMP _0xB1
_0xB2:
	CPI  R30,LOW(0x1)
	BRNE _0xB5
	CPI  R19,37
	BRNE _0xB6
	RCALL SUBOPT_0xF
	LDI  R16,LOW(0)
	RJMP _0xB1
_0xB6:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0xB7
	LDI  R17,LOW(1)
	RJMP _0xB1
_0xB7:
	CPI  R19,43
	BRNE _0xB8
	LDI  R21,LOW(43)
	RJMP _0xB1
_0xB8:
	CPI  R19,32
	BRNE _0xB9
	LDI  R21,LOW(32)
	RJMP _0xB1
_0xB9:
	RJMP _0xBA
_0xB5:
	CPI  R30,LOW(0x2)
	BRNE _0xBB
_0xBA:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0xBC
	ORI  R17,LOW(128)
	RJMP _0xB1
_0xBC:
	RJMP _0xBD
_0xBB:
	CPI  R30,LOW(0x3)
	BREQ PC+2
	RJMP _0xB1
_0xBD:
	CPI  R19,48
	BRLO _0xC0
	CPI  R19,58
	BRLO _0xC1
_0xC0:
	RJMP _0xBF
_0xC1:
	MOV  R18,R20
	LSL  R20
	LSL  R20
	ADD  R20,R18
	LSL  R20
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0xB1
_0xBF:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0xC5
	RCALL SUBOPT_0x10
	LD   R30,X
	RCALL SUBOPT_0x11
	RJMP _0xC6
_0xC5:
	CPI  R30,LOW(0x73)
	BRNE _0xC8
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x12
	RCALL _strlen
	MOV  R16,R30
	RJMP _0xC9
_0xC8:
	CPI  R30,LOW(0x70)
	BRNE _0xCB
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x12
	RCALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0xC9:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0xCC
_0xCB:
	CPI  R30,LOW(0x64)
	BREQ _0xCF
	CPI  R30,LOW(0x69)
	BRNE _0xD0
_0xCF:
	ORI  R17,LOW(4)
	RJMP _0xD1
_0xD0:
	CPI  R30,LOW(0x75)
	BRNE _0xD2
_0xD1:
	LDI  R30,LOW(_tbl10_G3*2)
	LDI  R31,HIGH(_tbl10_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0xD3
_0xD2:
	CPI  R30,LOW(0x58)
	BRNE _0xD5
	ORI  R17,LOW(8)
	RJMP _0xD6
_0xD5:
	CPI  R30,LOW(0x78)
	BREQ PC+2
	RJMP _0x104
_0xD6:
	LDI  R30,LOW(_tbl16_G3*2)
	LDI  R31,HIGH(_tbl16_G3*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0xD3:
	SBRS R17,2
	RJMP _0xD8
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x13
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0xD9
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0xD9:
	CPI  R21,0
	BREQ _0xDA
	SUBI R16,-LOW(1)
	RJMP _0xDB
_0xDA:
	ANDI R17,LOW(251)
_0xDB:
	RJMP _0xDC
_0xD8:
	RCALL SUBOPT_0x10
	RCALL SUBOPT_0x13
_0xDC:
_0xCC:
	SBRC R17,0
	RJMP _0xDD
_0xDE:
	CP   R16,R20
	BRSH _0xE0
	SBRS R17,7
	RJMP _0xE1
	SBRS R17,2
	RJMP _0xE2
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0xE3
_0xE2:
	LDI  R19,LOW(48)
_0xE3:
	RJMP _0xE4
_0xE1:
	LDI  R19,LOW(32)
_0xE4:
	RCALL SUBOPT_0xF
	SUBI R20,LOW(1)
	RJMP _0xDE
_0xE0:
_0xDD:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0xE5
_0xE6:
	CPI  R18,0
	BREQ _0xE8
	SBRS R17,3
	RJMP _0xE9
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM
	MOV  R30,R0
	RJMP _0x116
_0xE9:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x116:
	ST   -Y,R30
	RCALL SUBOPT_0x14
	CPI  R20,0
	BREQ _0xEB
	SUBI R20,LOW(1)
_0xEB:
	SUBI R18,LOW(1)
	RJMP _0xE6
_0xE8:
	RJMP _0xEC
_0xE5:
_0xEE:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	RCALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0xF0
	SBRS R17,3
	RJMP _0xF1
	SUBI R19,-LOW(7)
	RJMP _0xF2
_0xF1:
	SUBI R19,-LOW(39)
_0xF2:
_0xF0:
	SBRC R17,4
	RJMP _0xF4
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0xF6
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0xF5
_0xF6:
	ORI  R17,LOW(16)
	RJMP _0xF8
_0xF5:
	CP   R20,R18
	BRLO _0xFA
	SBRS R17,0
	RJMP _0xFB
_0xFA:
	RJMP _0xF9
_0xFB:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0xFC
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0xF8:
	SBRS R17,2
	RJMP _0xFD
	ANDI R17,LOW(251)
	ST   -Y,R21
	RCALL SUBOPT_0x14
	CPI  R20,0
	BREQ _0xFE
	SUBI R20,LOW(1)
_0xFE:
_0xFD:
_0xFC:
_0xF4:
	RCALL SUBOPT_0xF
	CPI  R20,0
	BREQ _0xFF
	SUBI R20,LOW(1)
_0xFF:
_0xF9:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0xEF
	RJMP _0xEE
_0xEF:
_0xEC:
	SBRS R17,0
	RJMP _0x100
_0x101:
	CPI  R20,0
	BREQ _0x103
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	RCALL SUBOPT_0x11
	RJMP _0x101
_0x103:
_0x100:
_0x104:
_0xC6:
	LDI  R16,LOW(0)
_0xB1:
	RJMP _0xAC
_0xAE:
	RCALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOV  R26,R28
	MOV  R27,R29
	RCALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,6
	RCALL SUBOPT_0x15
	ST   Y,R30
	STD  Y+1,R31
	MOV  R26,R28
	MOV  R27,R29
	ADIW R26,4
	RCALL SUBOPT_0x15
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	RCALL __print_G3
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G4:
	.BYTE 0x4

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G4:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	RCALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G4)
	SBCI R31,HIGH(-__base_y_G4)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	RCALL SUBOPT_0x16
	LDD  R7,Y+1
	LDD  R8,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	RCALL __lcd_ready
	LDI  R30,LOW(2)
	RCALL SUBOPT_0x16
	RCALL __lcd_ready
	LDI  R30,LOW(12)
	RCALL SUBOPT_0x16
	RCALL __lcd_ready
	RCALL SUBOPT_0xD
	RCALL __lcd_write_data
	CLR  R30
	MOV  R8,R30
	MOV  R7,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R7
	CP   R9,R7
	BRSH _0x10C
	__lcd_putchar1:
	INC  R8
	RCALL SUBOPT_0xC
	ST   -Y,R8
	RCALL _lcd_gotoxy
	brts __lcd_putchar0
_0x10C:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G4:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G4:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R9,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G4,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G4,3
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x17
	RCALL SUBOPT_0x17
	RCALL __long_delay_G4
	LDI  R30,LOW(32)
	ST   -Y,R30
	RCALL __lcd_init_write_G4
	RCALL __long_delay_G4
	LDI  R30,LOW(40)
	RCALL SUBOPT_0x16
	RCALL __long_delay_G4
	LDI  R30,LOW(4)
	RCALL SUBOPT_0x16
	RCALL __long_delay_G4
	LDI  R30,LOW(133)
	RCALL SUBOPT_0x16
	RCALL __long_delay_G4
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	RCALL _lcd_read_byte0_G4
	CPI  R30,LOW(0x5)
	BREQ _0x111
	CLR  R30
	RJMP _0x112
_0x111:
	RCALL __lcd_ready
	LDI  R30,LOW(6)
	RCALL SUBOPT_0x16
	RCALL _lcd_clear
	LDI  R30,LOW(1)
_0x112:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x0:
	CLR  R30
	OUT  0x18,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	MOV  R30,R16
	CPI  R30,0
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 9 TIMES
SUBOPT_0x2:
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,17
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x3:
	RCALL _sprintf
	ADIW R28,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4:
	MOV  R30,R28
	MOV  R31,R29
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x5:
	MOV  R30,R28
	MOV  R31,R29
	ADIW R30,2
	ST   -Y,R31
	ST   -Y,R30
	RJMP _Affiche_LCD

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	ST   -Y,R31
	ST   -Y,R30
	MOV  R30,R19
	CLR  R31
	CLR  R22
	CLR  R23
	RCALL __PUTPARD1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	RCALL _sprintf
	ADIW R28,8
	RJMP SUBOPT_0x2

;OPTIMIZER ADDED SUBROUTINE, CALLED 11 TIMES
SUBOPT_0x8:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _delay_ms

;OPTIMIZER ADDED SUBROUTINE, CALLED 8 TIMES
SUBOPT_0x9:
	LDI  R30,LOW(500)
	LDI  R31,HIGH(500)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	LDI  R30,LOW(20)
	LDI  R31,HIGH(20)
	RJMP SUBOPT_0x8

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	ST   -Y,R31
	ST   -Y,R30
	RJMP _lcd_puts

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	LDI  R30,LOW(1)
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	LD   R26,Y
	LDD  R27,Y+1
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0xF:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x10:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x11:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x12:
	RCALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x13:
	RCALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x14:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	RJMP __put_G3

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x15:
	RCALL __ADDW2R15
	RCALL __GETW1P
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES
SUBOPT_0x16:
	ST   -Y,R30
	RJMP __lcd_write_data

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x17:
	RCALL __long_delay_G4
	LDI  R30,LOW(48)
	ST   -Y,R30
	RJMP __lcd_init_write_G4

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm 
	tst  r0
	breq __strlenf1
	adiw r26,1
	adiw r30,1
	rjmp __strlenf0
__strlenf1:
	mov  r30,r26
	mov  r31,r27
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x3E8
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__PUTWP1:
	ST   X+,R30
	ST   X,R31
	RET

__GETW1PF:
	LPM
	ADIW R30,1
	MOV  R1,R0
	LPM 
	MOV  R31,R0
	MOV  R30,R1
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__LOADLOCR2P:
	LD   R16,Y+
	LD   R17,Y+
	RET

